<template>
  <div>
    <div class="card">
      <nav class="navbar has-background-white-bis">
        <div class="navbar-brand">
          <span class="navbar-item title is-2">Listado de Ranking</span>
        </div>
        <div class="navbar-menu">
          <div class="navbar-end">
            <div class="navbar-item">
              <a class="button regular is-purple is-medium" @click="add">
                <span>Agregar</span>
                <span><i class="fa fa-plus" style=" margin-left: 9px;"></i></span>
              </a>
            </div>
          </div>
        </div>
      </nav>
      <div class="section">
          <b-table :loading="isLoading" :data="data">
              <b-table-column field="rankingTypeName" label="Tipo de Ranking" width="60"  sortable  v-slot="props">
                {{props.row.rankingTypeName}}
            </b-table-column>
              <b-table-column field="playerName" label="Jugador" width="40"  sortable  v-slot="props">
                {{props.row.playerName}}
                <br>
                {{props.row.secondPlayerName}}

            </b-table-column>
             <b-table-column field="playerRanking" label="Ranking" width="40"  sortable  v-slot="props">
                {{props.row.playerRanking}}
            </b-table-column>
             <b-table-column field="point" label="Puntos" width="40"  sortable  v-slot="props">
                {{props.row.point}}
            </b-table-column>
            
            
              <b-table-column  label="Acciones" width="40"   v-slot="props">
               <div class="buttons is-centered" style="
    margin-left: -74px;
">
              <b-tooltip
                type="is-warning"
                label="Editar"
              >
                <b-button
                  outlined
                  @click="edit(props.row.id)"
                  type="advise"
                  ><b-icon icon="pencil"></b-icon
                ></b-button>
              </b-tooltip>
              <b-tooltip
                type="is-danger"
                label="Eliminar"
              >
                <b-button
                  outlined
                  @click="remove(props.row.id)"
                  type="alert"
                  ><b-icon icon="delete"></b-icon
                ></b-button>
              </b-tooltip>
            </div>
            </b-table-column>
                <template #empty>
                <div class="has-text-centered title is-4">😢 No hay registro</div>
            </template>
          </b-table>
      </div>
    </div>
  </div>
</template>
<script lang='ts'>
import RankingModel from "@/models/ranking.model";
import RankingService from "@/services/rankingService";
import { Component, Vue } from "vue-property-decorator";

@Component
export default class RankingTableComponent extends Vue {

  data:Array<RankingModel> = [];
  isLoading:boolean = false;
  rankingService:RankingService = new RankingService();
  created() {
        this.getRankings();
  }


    public add() {
        this.$router.push(`${this.$router.currentRoute.path}/agregar`)
    }

    public edit(id: number) {
        this.$router.push(`${this.$router.currentRoute.path}/editar/${id}`)
    }

    public remove(id: number) {
        this.$buefy.dialog.confirm({
            title: 'Confirmación',
            message: '¿Desea eliminar este registro?',
            confirmText: 'Adelante!',
            cancelText: 'Cancelar',
            type: 'is-danger',
            size: 'is-medium',
            hasIcon: true,
            onConfirm: () => this.confirmRemove(id)
        })
    }

     protected async confirmRemove(id: number) {
           this.rankingService.deleteRanking(id).then(resp =>{
               this.getRankings();
           })

    }

  getRankings(){
      this.isLoading = true;
     this.rankingService.getRanking().then(resp =>{
         this.data = resp.data;
     }).finally(()=>{
         this.isLoading = false;
     })
  }
 
}
</script>


